diff --git a/pki/base/common/src/com/netscape/cms/profile/constraint/EnrollConstraint.java b/pki/base/common/src/com/netscape/cms/profile/constraint/EnrollConstraint.java
index 0723a72c382918c64f05fc5f13e1d64722e58aa0..a03eadcd57b550a7edc796fa0da0689058462ba7 100644
--- a/pki/base/common/src/com/netscape/cms/profile/constraint/EnrollConstraint.java
+++ b/pki/base/common/src/com/netscape/cms/profile/constraint/EnrollConstraint.java
@@ -49,12 +49,12 @@ public abstract class EnrollConstraint implements IPolicyConstraint {
     public static final String CONFIG_NAME = "name";
 
     protected IConfigStore mConfig = null;
-    protected Vector mConfigNames = new Vector();
+    protected Vector<String> mConfigNames = new Vector<String>();
 
     public EnrollConstraint() {
     }
 
-    public Enumeration getConfigNames() {
+    public Enumeration<String> getConfigNames() {
         return mConfigNames.elements();
     }
 
@@ -175,10 +175,10 @@ public abstract class EnrollConstraint implements IPolicyConstraint {
         }
         if (exts == null)
             return null;
-        Enumeration e = exts.getElements();
+        Enumeration<Extension> e = exts.getAttributes();
 
         while (e.hasMoreElements()) {
-            Extension ext = (Extension) e.nextElement();
+            Extension ext = e.nextElement();
 
             if (ext.getExtensionId().toString().equals(name)) {
                 return ext;
diff --git a/pki/base/common/src/com/netscape/cms/profile/constraint/UniqueSubjectNameConstraint.java b/pki/base/common/src/com/netscape/cms/profile/constraint/UniqueSubjectNameConstraint.java
index 89b8d460261653a0e76afd7883ef9eebcc39b647..72498d39b600895cbef59996c97e2d3daeaa3f3f 100644
--- a/pki/base/common/src/com/netscape/cms/profile/constraint/UniqueSubjectNameConstraint.java
+++ b/pki/base/common/src/com/netscape/cms/profile/constraint/UniqueSubjectNameConstraint.java
@@ -110,7 +110,7 @@ public class UniqueSubjectNameConstraint extends EnrollConstraint {
         } else {
             try {
                 ext = (KeyUsageExtension) extensions.get(
-                    KeyUsageExtension.NAME);
+                    KeyUsageExtension.class.getSimpleName());
             } catch (IOException e) {
             // extension isn't there.
             }
@@ -180,14 +180,14 @@ public class UniqueSubjectNameConstraint extends EnrollConstraint {
         else {
             certsubjectname = sn.toString();
             String filter = "x509Cert.subject=" + certsubjectname;
-            Enumeration sameSubjRecords = null;
+            Enumeration<ICertRecord> sameSubjRecords = null;
             try {
                 sameSubjRecords = certdb.findCertRecords(filter);
             } catch (EBaseException e) {
                 CMS.debug("UniqueSubjectNameConstraint exception: "+e.toString());
             }
             while (sameSubjRecords != null && sameSubjRecords.hasMoreElements()) {
-                ICertRecord rec = (ICertRecord) sameSubjRecords.nextElement();
+                ICertRecord rec =  sameSubjRecords.nextElement();
                 String status = rec.getStatus();
 
                 IRevocationInfo revocationInfo = rec.getRevocationInfo();
@@ -197,10 +197,10 @@ public class UniqueSubjectNameConstraint extends EnrollConstraint {
                     CRLExtensions crlExts = revocationInfo.getCRLEntryExtensions();
 
                     if (crlExts != null) {
-                        Enumeration enumx = crlExts.getElements();
+                        Enumeration<Extension> enumx = crlExts.getElements();
 
                         while (enumx.hasMoreElements()) {
-                            Extension ext = (Extension) enumx.nextElement();
+                            Extension ext =  enumx.nextElement();
 
                             if (ext instanceof CRLReasonExtension) {
                                 reason = ((CRLReasonExtension) ext).getReason();
diff --git a/pki/base/common/src/com/netscape/cms/profile/def/CRLDistributionPointsExtDefault.java b/pki/base/common/src/com/netscape/cms/profile/def/CRLDistributionPointsExtDefault.java
index 6dfb24c135b7e67baaa5d0dd178764ad73a15878..5a551033c0d143de88d970227c0e21aaf06ba832 100644
--- a/pki/base/common/src/com/netscape/cms/profile/def/CRLDistributionPointsExtDefault.java
+++ b/pki/base/common/src/com/netscape/cms/profile/def/CRLDistributionPointsExtDefault.java
@@ -110,7 +110,7 @@ public class CRLDistributionPointsExtDefault extends EnrollExtDefault {
     }
 
 
-    public Enumeration getConfigNames() {
+    public Enumeration<String> getConfigNames() {
         refreshConfigAndValueNames();
         return super.getConfigNames();
     }
@@ -245,7 +245,7 @@ public class CRLDistributionPointsExtDefault extends EnrollExtDefault {
                 {
                     return;
                 }
-                Vector v = parseRecords(value);
+                Vector<NameValuePairs> v = parseRecords(value);
                 int size = v.size();
               
                 boolean critical = ext.isCritical();
@@ -253,7 +253,7 @@ public class CRLDistributionPointsExtDefault extends EnrollExtDefault {
 
                 for (; i < size; i++) {
                     NameValuePairs nvps = (NameValuePairs) v.elementAt(i);
-                    Enumeration names = nvps.getNames();
+                    Enumeration<String> names = nvps.getNames();
                     String pointType = null;
                     String pointValue = null;
                     String issuerType = null;
@@ -444,7 +444,7 @@ public class CRLDistributionPointsExtDefault extends EnrollExtDefault {
 
             StringBuffer sb = new StringBuffer();
 
-            Vector recs = new Vector();
+            Vector<NameValuePairs> recs = new Vector<NameValuePairs>();
             int num = getNumPoints();
 
             for (int i = 0; i < num; i++) {
diff --git a/pki/base/common/src/com/netscape/cms/profile/def/CertificatePoliciesExtDefault.java b/pki/base/common/src/com/netscape/cms/profile/def/CertificatePoliciesExtDefault.java
index 14eec785ed5e5c39be98154f33ba994120654cc0..63a4d303b7bd45ed1ce8f07ea73e0a5158231114 100644
--- a/pki/base/common/src/com/netscape/cms/profile/def/CertificatePoliciesExtDefault.java
+++ b/pki/base/common/src/com/netscape/cms/profile/def/CertificatePoliciesExtDefault.java
@@ -149,7 +149,7 @@ public class CertificatePoliciesExtDefault extends EnrollExtDefault {
     }
 
 
-    public Enumeration getConfigNames() {
+    public Enumeration<String> getConfigNames() {
         refreshConfigAndValueNames();
         return super.getConfigNames();
     }
@@ -245,9 +245,9 @@ public class CertificatePoliciesExtDefault extends EnrollExtDefault {
         return null;
     }
 
-    private Hashtable buildRecords(String value) throws EPropertyException {
+    private Hashtable<String, String> buildRecords(String value) throws EPropertyException {
         StringTokenizer st = new StringTokenizer(value, "\r\n");
-        Hashtable table = new Hashtable();
+        Hashtable<String, String> table = new Hashtable<String, String>();
         while (st.hasMoreTokens()) {
             String token = (String) st.nextToken();
             int index = token.indexOf(":");
@@ -287,12 +287,12 @@ public class CertificatePoliciesExtDefault extends EnrollExtDefault {
                         getExtension(PKIXExtensions.CertificatePolicies_Id.toString(), 
                             info);
                 
-                Hashtable h = buildRecords(value);
+                Hashtable<String, String> h = buildRecords(value);
 
                 String numStr = (String)h.get(CONFIG_POLICY_NUM);
                 int size = Integer.parseInt(numStr);
 
-                Vector certificatePolicies = new Vector();
+                Vector<CertificatePolicyInfo> certificatePolicies = new Vector<CertificatePolicyInfo>();
                 for (int i = 0; i < size; i++) {
                     String enable = (String)h.get(CONFIG_PREFIX+i+SEPARATOR+CONFIG_POLICY_ENABLE);
                     CertificatePolicyInfo cinfo = null;
@@ -359,7 +359,7 @@ public class CertificatePoliciesExtDefault extends EnrollExtDefault {
         }
     }
 
-    public String getValue(String name, Locale locale,
+	public String getValue(String name, Locale locale,
         X509CertInfo info)
         throws EPropertyException {
         CertificatePoliciesExtension ext = null;
@@ -392,17 +392,19 @@ public class CertificatePoliciesExtDefault extends EnrollExtDefault {
 
             StringBuffer sb = new StringBuffer();
             int num_policies = getNumPolicies();
-            int num_qualifiers = DEF_NUM_QUALIFIERS;
             sb.append(CONFIG_POLICY_NUM);
             sb.append(":");
             sb.append(num_policies);
             sb.append("\n");
-            Vector infos = null;
+            
+            Vector<CertificatePolicyInfo> infos ;
             try {
-                infos = (Vector)(ext.get(CertificatePoliciesExtension.INFOS)); 
+                @SuppressWarnings("unchecked")
+                Vector<CertificatePolicyInfo> certPolicyInfos = (Vector<CertificatePolicyInfo>)ext.get(CertificatePoliciesExtension.INFOS); 
+                infos = certPolicyInfos;
             } catch (IOException ee) {
+                infos  =null;
             }
-            Enumeration policies = ext.getElements();
 
             for (int i = 0; i < num_policies; i++) {
                 int qSize = 0;
@@ -411,7 +413,7 @@ public class CertificatePoliciesExtDefault extends EnrollExtDefault {
                 PolicyQualifiers qualifiers = null;
                 if (infos.size() > 0) { 
                     CertificatePolicyInfo cinfo = 
-                        (CertificatePolicyInfo) infos.elementAt(0);
+                         infos.elementAt(0);
                 
                     CertificatePolicyId id1 = cinfo.getPolicyIdentifier();               
                     policyId = id1.getIdentifier().toString();
@@ -539,7 +541,6 @@ public class CertificatePoliciesExtDefault extends EnrollExtDefault {
 
     public String getText(Locale locale) {
         StringBuffer sb = new StringBuffer();
-        String numPolicies = getConfig(CONFIG_POLICY_NUM);
         int num = getNumPolicies();
         int num1 = getNumQualifiers();
 
@@ -622,7 +623,7 @@ public class CertificatePoliciesExtDefault extends EnrollExtDefault {
 
         try {
             boolean critical = getConfigBoolean(CONFIG_CRITICAL);
-            Vector certificatePolicies = new Vector();
+            Vector<CertificatePolicyInfo> certificatePolicies = new Vector<CertificatePolicyInfo>();
             int num = getNumPolicies();
             CMS.debug("CertificatePoliciesExtension: createExtension: number of policies="+num);
             IConfigStore config = getConfigStore();
@@ -731,7 +732,7 @@ public class CertificatePoliciesExtDefault extends EnrollExtDefault {
 
         int nums[] = null;
         if (noticeNums != null && noticeNums.length() > 0) {
-            Vector numsVector = new Vector();
+            Vector<String> numsVector = new Vector<String>();
             StringTokenizer tokens = new StringTokenizer(noticeNums, ";");
             while (tokens.hasMoreTokens()) {
                 String num = tokens.nextToken().trim();
diff --git a/pki/base/common/src/com/netscape/cms/profile/def/EnrollDefault.java b/pki/base/common/src/com/netscape/cms/profile/def/EnrollDefault.java
index b5afc1c79e39049eaaad7e3cea22bd02a685255f..239765abbee464e97c137e0f66ec54600dba5a4f 100644
--- a/pki/base/common/src/com/netscape/cms/profile/def/EnrollDefault.java
+++ b/pki/base/common/src/com/netscape/cms/profile/def/EnrollDefault.java
@@ -80,13 +80,13 @@ public abstract class EnrollDefault implements IPolicyDefault, ICertInfoPolicyDe
     public static final String GN_OID_NAME = "OIDName";
 
     protected IConfigStore mConfig = null;
-    protected Vector mConfigNames = new Vector();
-    protected Vector mValueNames = new Vector();
+    protected Vector<String> mConfigNames = new Vector<String>();
+    protected Vector<String> mValueNames = new Vector<String>();
 
     public EnrollDefault() {
     }
 
-    public Enumeration getConfigNames() {
+    public Enumeration<String> getConfigNames() {
         return mConfigNames.elements();
     }
 
@@ -212,7 +212,7 @@ public abstract class EnrollDefault implements IPolicyDefault, ICertInfoPolicyDe
         mValueNames.addElement(name);
     }
 
-    public Enumeration getValueNames() {
+    public Enumeration<String> getValueNames() {
         return mValueNames.elements();
     }
 
@@ -291,10 +291,10 @@ public abstract class EnrollDefault implements IPolicyDefault, ICertInfoPolicyDe
                     info.get(X509CertInfo.EXTENSIONS);
             if (exts == null)
                 return;
-            Enumeration e = exts.getNames();
+            Enumeration<String> e = exts.getNames();
 
             while (e.hasMoreElements()) {
-                String n = (String) e.nextElement();
+                String n =  e.nextElement();
                 Extension ext = (Extension) exts.get(n);
 
                 if (ext.getExtensionId().toString().equals(name)) {
@@ -323,10 +323,10 @@ public abstract class EnrollDefault implements IPolicyDefault, ICertInfoPolicyDe
     protected Extension getExtension(String name, CertificateExtensions exts) {
         if (exts == null)
             return null;
-        Enumeration e = exts.getElements();
+        Enumeration<Extension> e = exts.getAttributes();
 
         while (e.hasMoreElements()) {
-            Extension ext = (Extension) e.nextElement();
+            Extension ext = e.nextElement();
 
             if (ext.getExtensionId().toString().equals(name)) {
                 return ext;
@@ -515,7 +515,7 @@ public abstract class EnrollDefault implements IPolicyDefault, ICertInfoPolicyDe
               String realm = nameValue.substring(pos0 + 1, pos1).trim();
               String name_type = nameValue.substring(pos1 + 1, pos2).trim();
               String name_strings = nameValue.substring(pos2 + 1).trim();
-              Vector strings = new Vector();
+              Vector<String> strings = new Vector<String>();
               StringTokenizer st = new StringTokenizer(name_strings, ",");
               while (st.hasMoreTokens()) {
                      strings.addElement(st.nextToken());
@@ -637,19 +637,19 @@ public abstract class EnrollDefault implements IPolicyDefault, ICertInfoPolicyDe
         return true;
     }
 
-    protected String buildRecords(Vector recs) throws EPropertyException {
+    protected String buildRecords(Vector<NameValuePairs> recs) throws EPropertyException {
         StringBuffer sb = new StringBuffer();
 
         for (int i = 0; i < recs.size(); i++) {
-            NameValuePairs pairs = (NameValuePairs) recs.elementAt(i);
+            NameValuePairs pairs =  recs.elementAt(i);
 
             sb.append("Record #");
             sb.append(i);
             sb.append("\r\n");
-            Enumeration e = pairs.getNames();
+            Enumeration<String> e = pairs.getNames();
 
             while (e.hasMoreElements()) {
-                String key = (String) e.nextElement();
+                String key = e.nextElement();
                 String val = pairs.getValue(key);
 
                 sb.append(key);
@@ -663,21 +663,21 @@ public abstract class EnrollDefault implements IPolicyDefault, ICertInfoPolicyDe
         return sb.toString();
     }
 
-    protected Vector parseRecords(String value) throws EPropertyException {
+    protected Vector<NameValuePairs> parseRecords(String value) throws EPropertyException {
         StringTokenizer st = new StringTokenizer(value, "\r\n");
         int num = 0;
-        Vector v = new Vector();
+        Vector<NameValuePairs> v = new Vector<NameValuePairs>();
         NameValuePairs nvps = null;
 
         while (st.hasMoreTokens()) {
-            String token = (String) st.nextToken();
+            String token =  st.nextToken();
 
             if (token.equals("Record #" + num)) {
                 CMS.debug("parseRecords: Record" + num);
                 nvps = new NameValuePairs();
                 v.addElement(nvps);
                 try {
-                    token = (String) st.nextToken();
+                    token =  st.nextToken();
                 } catch (NoSuchElementException e) { 
                     v.removeElementAt(num);
                     CMS.debug(e.toString());
@@ -761,7 +761,7 @@ public abstract class EnrollDefault implements IPolicyDefault, ICertInfoPolicyDe
         return locale;
     }
 
-    public String toGeneralNameString(GeneralName gn) {
+    public String toGeneralNameString(GeneralNameInterface gn) {
         int type = gn.getType(); 
         // Sun's General Name is not consistent, so we need
         // to do a special case for directory string
diff --git a/pki/base/common/src/com/netscape/cms/profile/def/FreshestCRLExtDefault.java b/pki/base/common/src/com/netscape/cms/profile/def/FreshestCRLExtDefault.java
index 7b9bcd5259b2737db9af00a3d45d4684c74411a9..13af0426e7e5736a48aa5310e63dac80a06a704c 100644
--- a/pki/base/common/src/com/netscape/cms/profile/def/FreshestCRLExtDefault.java
+++ b/pki/base/common/src/com/netscape/cms/profile/def/FreshestCRLExtDefault.java
@@ -123,7 +123,7 @@ public class FreshestCRLExtDefault extends EnrollExtDefault {
     }
 
 
-    public Enumeration getConfigNames() {
+    public Enumeration<String> getConfigNames() {
         refreshConfigAndValueNames();
         return super.getConfigNames();
     }
@@ -228,7 +228,7 @@ public class FreshestCRLExtDefault extends EnrollExtDefault {
                         getExtension(FreshestCRLExtension.OID, 
                             info);
 
-                Vector v = parseRecords(value);
+                Vector<NameValuePairs> v = parseRecords(value);
                 int size = v.size();
               
                 boolean critical = ext.isCritical();
@@ -236,7 +236,7 @@ public class FreshestCRLExtDefault extends EnrollExtDefault {
 
                 for (; i < size; i++) {
                     NameValuePairs nvps = (NameValuePairs) v.elementAt(i);
-                    Enumeration names = nvps.getNames();
+                    Enumeration<String> names = nvps.getNames();
                     String pointType = null;
                     String pointValue = null;
                     String issuerType = null;
@@ -389,7 +389,7 @@ public class FreshestCRLExtDefault extends EnrollExtDefault {
 
             StringBuffer sb = new StringBuffer();
 
-            Vector recs = new Vector();
+            Vector<NameValuePairs> recs = new Vector<NameValuePairs>();
             int num = getNumPoints();
             for (int i = 0; i < num; i++) {
                 NameValuePairs pairs = null;
diff --git a/pki/base/common/src/com/netscape/cms/profile/def/IssuerAltNameExtDefault.java b/pki/base/common/src/com/netscape/cms/profile/def/IssuerAltNameExtDefault.java
index 8f8837ebdfb33888285e3905385ed18d68817a3e..40bd48766362037641f25bf4c88a98dc27557078 100644
--- a/pki/base/common/src/com/netscape/cms/profile/def/IssuerAltNameExtDefault.java
+++ b/pki/base/common/src/com/netscape/cms/profile/def/IssuerAltNameExtDefault.java
@@ -239,7 +239,7 @@ public class IssuerAltNameExtDefault extends EnrollExtDefault {
                 GeneralNames names = (GeneralNames)
                     ext.get(IssuerAlternativeNameExtension.ISSUER_NAME);
                 StringBuffer sb = new StringBuffer();
-                Enumeration e = names.elements();
+                Enumeration<GeneralNameInterface> e = names.elements();
 
                 while (e.hasMoreElements()) {
                     GeneralName gn = (GeneralName) e.nextElement();
diff --git a/pki/base/common/src/com/netscape/cms/profile/def/NameConstraintsExtDefault.java b/pki/base/common/src/com/netscape/cms/profile/def/NameConstraintsExtDefault.java
index f6ddd91536a2f18dc5341c98dbad19e9ac97e390..7776238af57e8d10f3e9c5b5edcc24d62d88e329 100644
--- a/pki/base/common/src/com/netscape/cms/profile/def/NameConstraintsExtDefault.java
+++ b/pki/base/common/src/com/netscape/cms/profile/def/NameConstraintsExtDefault.java
@@ -163,7 +163,7 @@ public class NameConstraintsExtDefault extends EnrollExtDefault {
     }
 
 
-    public Enumeration getConfigNames() {
+    public Enumeration<String> getConfigNames() {
         refreshConfigAndValueNames();
         return super.getConfigNames();
     }
@@ -319,9 +319,9 @@ public class NameConstraintsExtDefault extends EnrollExtDefault {
                     return;
                 }
 
-                Vector v = parseRecords(value);
+                Vector<NameValuePairs> v = parseRecords(value);
 
-                Vector permittedSubtrees = createSubtrees(locale, v);
+                Vector<GeneralSubtree> permittedSubtrees = createSubtrees(locale, v);
 
                 ext.set(NameConstraintsExtension.PERMITTED_SUBTREES, 
                     new GeneralSubtrees(permittedSubtrees));
@@ -337,9 +337,9 @@ public class NameConstraintsExtDefault extends EnrollExtDefault {
                               "blank value for excluded subtrees ... returning");
                     return;
                 }
-                Vector v = parseRecords(value);
+                Vector<NameValuePairs> v = parseRecords(value);
 
-                Vector excludedSubtrees = createSubtrees(locale, v);
+                Vector<GeneralSubtree> excludedSubtrees = createSubtrees(locale, v);
 
                 ext.set(NameConstraintsExtension.EXCLUDED_SUBTREES, 
                     new GeneralSubtrees(excludedSubtrees));
@@ -360,18 +360,18 @@ public class NameConstraintsExtDefault extends EnrollExtDefault {
         }
     }
 
-    private Vector createSubtrees(Locale locale, Vector v) throws EPropertyException {
+    private Vector<GeneralSubtree> createSubtrees(Locale locale, Vector<NameValuePairs> v) throws EPropertyException {
         int size = v.size();
         String choice = null;
         String val = "";
         String minS = null;
         String maxS = null;
 
-        Vector subtrees = new Vector();
+        Vector<GeneralSubtree> subtrees = new Vector<GeneralSubtree>();
 
         for (int i = 0; i < size; i++) {
             NameValuePairs nvps = (NameValuePairs) v.elementAt(i);
-            Enumeration names = nvps.getNames();
+            Enumeration<String> names = nvps.getNames();
 
             while (names.hasMoreElements()) {
                 String name1 = (String) names.nextElement();
@@ -517,10 +517,10 @@ public class NameConstraintsExtDefault extends EnrollExtDefault {
 
     private String getSubtreesInfo(NameConstraintsExtension ext, 
         GeneralSubtrees subtrees) throws EPropertyException {
-        Vector trees = subtrees.getSubtrees();
+        Vector<GeneralSubtree> trees = subtrees.getSubtrees();
         int size = trees.size();
 
-        Vector recs = new Vector();
+        Vector<NameValuePairs> recs = new Vector<NameValuePairs>();
 
         for (int i = 0; i < size; i++) {
             GeneralSubtree tree = (GeneralSubtree) trees.elementAt(i);
@@ -606,7 +606,7 @@ public class NameConstraintsExtDefault extends EnrollExtDefault {
 
             boolean critical = getConfigBoolean(CONFIG_CRITICAL);
 
-            Vector v = new Vector();
+            Vector<GeneralSubtree> v = new Vector<GeneralSubtree>();
 
             for (int i = 0; i < num; i++) {
                 String enable = getConfig(CONFIG_PERMITTED_ENABLE + i);
@@ -621,7 +621,7 @@ public class NameConstraintsExtDefault extends EnrollExtDefault {
                 }
             }
 
-            Vector v1 = new Vector();
+            Vector<GeneralSubtree> v1 = new Vector<GeneralSubtree>();
 
             num = getNumExcluded();
             for (int i = 0; i < num; i++) {
diff --git a/pki/base/common/src/com/netscape/cms/profile/def/PolicyMappingsExtDefault.java b/pki/base/common/src/com/netscape/cms/profile/def/PolicyMappingsExtDefault.java
index 19bfb361517317005b2ab8751728fe6adbd85ffa..05899e2c02203a78009d6d8deb20779366111006 100644
--- a/pki/base/common/src/com/netscape/cms/profile/def/PolicyMappingsExtDefault.java
+++ b/pki/base/common/src/com/netscape/cms/profile/def/PolicyMappingsExtDefault.java
@@ -110,7 +110,7 @@ public class PolicyMappingsExtDefault extends EnrollExtDefault {
         super.setConfig(name, value);
     }
 
-    public Enumeration getConfigNames() {
+    public Enumeration<String> getConfigNames() {
         refreshConfigAndValueNames();
         return super.getConfigNames();
     }
@@ -209,17 +209,17 @@ public class PolicyMappingsExtDefault extends EnrollExtDefault {
                 if(ext == null)  {
                     return;
                 } 
-                Vector v = parseRecords(value);
+                Vector<NameValuePairs> v = parseRecords(value);
                 int size = v.size();
 
                 String issuerPolicyId = null;
                 String subjectPolicyId = null;
                 String enable = null;
-                Vector policyMaps = new Vector();
+                Vector<CertificatePolicyMap> policyMaps = new Vector<CertificatePolicyMap>();
 
                 for (int i = 0; i < size; i++) {
                     NameValuePairs nvps = (NameValuePairs) v.elementAt(i);
-                    Enumeration names = nvps.getNames();
+                    Enumeration<String> names = nvps.getNames();
 
                     while (names.hasMoreElements()) {
                         String name1 = (String) names.nextElement();
@@ -313,12 +313,12 @@ public class PolicyMappingsExtDefault extends EnrollExtDefault {
 
             int num_mappings = getNumMappings();
 
-            Enumeration maps = ext.getMappings();
+            Enumeration<CertificatePolicyMap> maps = ext.getMappings();
          
             int num = 0;
             StringBuffer sb = new StringBuffer();
 
-            Vector recs = new Vector();
+            Vector<NameValuePairs> recs = new Vector<NameValuePairs>();
 
             for (int i = 0; i < num_mappings; i++) {
                 NameValuePairs pairs = new NameValuePairs();
@@ -391,7 +391,7 @@ public class PolicyMappingsExtDefault extends EnrollExtDefault {
 
         try {
             boolean critical = getConfigBoolean(CONFIG_CRITICAL);
-            Vector policyMaps = new Vector();
+            Vector<CertificatePolicyMap> policyMaps = new Vector<CertificatePolicyMap>();
             int num = getNumMappings();
 
             for (int i = 0; i < num; i++) { 
diff --git a/pki/base/common/src/com/netscape/cms/profile/def/SubjectAltNameExtDefault.java b/pki/base/common/src/com/netscape/cms/profile/def/SubjectAltNameExtDefault.java
index 64d822e8ff94b01e017ea8d50878e0d2e0c92b80..8adc94dc61f46aad0d169e379c0406bd6ba9e0a9 100644
--- a/pki/base/common/src/com/netscape/cms/profile/def/SubjectAltNameExtDefault.java
+++ b/pki/base/common/src/com/netscape/cms/profile/def/SubjectAltNameExtDefault.java
@@ -24,7 +24,6 @@ import java.util.Locale;
 import java.util.StringTokenizer;
 import java.util.UUID;
 
-import netscape.security.x509.GeneralName;
 import netscape.security.x509.GeneralNameInterface;
 import netscape.security.x509.GeneralNames;
 import netscape.security.x509.PKIXExtensions;
@@ -159,7 +158,7 @@ public class SubjectAltNameExtDefault extends EnrollExtDefault {
         super.setConfig(name, value);
     }
 
-    public Enumeration getConfigNames() {
+    public Enumeration<String> getConfigNames() {
         refreshConfigAndValueNames();
         return super.getConfigNames();
     }
@@ -357,13 +356,10 @@ public class SubjectAltNameExtDefault extends EnrollExtDefault {
                 GeneralNames names = (GeneralNames)
                     ext.get(SubjectAlternativeNameExtension.SUBJECT_NAME);
                 StringBuffer sb = new StringBuffer();
-                Enumeration e = names.elements();
+                Enumeration<GeneralNameInterface> e = names.elements();
 
                 while (e.hasMoreElements()) {
-                    Object o = (Object) e.nextElement();
-                    if (!(o instanceof GeneralName))
-                            continue;
-                    GeneralName gn = (GeneralName) o;
+                    GeneralNameInterface gn = e.nextElement();
 
                     if (!sb.toString().equals("")) {
                         sb.append("\r\n");
